/*5- En este problema resuelto se busca ejemplificar el uso de punteros a funciones. Cree una rutina para el clculo de promedios, que sea lo suficientemente genrica y capaz de calcular el promedio sobre cualquier otra funcin que reciba un entero como parmetro y retorne un real de doble precisin. Para ejemplificar el uso de 'promedio()' construya dos funciones (lineal y cuadrtica). Para el problema en Pascal, si la compilacin se lleva a cabo con FreePascal deber usarse la opcin -Mtp que habilita la compatibilidad con TurboPascal (lo cual permite el pasaje de funciones y/o procedimientos como parmetros de otras funciones y/o procedimientos).*/
/*Solucin en lenguaje C*/

#include <stdio.h>
/* La funcin 'promedio()' es genrica, en el sentido de que */
/* es capaz de calcular el promedio de cualquier funcin */
/* recibida como parmetro. */
double promedio(double (*func)(int), int inicio, int fin)
{
	double acum = 0.0;
	int x;
	for (x = inicio; x < fin; x++)
		acum += (*func)(x);
	return acum / (fin - inicio);
}

/* Funcin lineal: f(x) = x */
double lineal(int x)
{
	return (double)x;
}

/* Funcin cuadrtica: f(x) = x^2 */
double cuadratica(int x)
{
	return (double)x*x;
}

int main()
{
	printf("Promedio de f(x) = x (0 <= x < 10) : %.2f\n", promedio(lineal, 0, 10));
	printf("Promedio de f(x) = x^2 (4 <= x < 6) : %.2f\n", promedio(cuadratica, 4, 6));
	return 0;
}